# 配置环境变量

## 1. 在 `compose.yaml` 文件中添加引用

插件的环境变量全部是在 ws 服务中，比如豆包插件所使用的环境变量如下：

```yaml
  ws:
    image: python:3.12-slim
    restart: always
    command: bash -c "pip install -r requirements.txt && python server.py"
    working_dir: /app
    environment:  // [!code focus]
      TZ: "Asia/Shanghai"
      ENV: ${ENV}
      DOUBAO_API_KEY: ${DOUBAO_API_KEY} // [!code focus]
      DOUBAO_MODEL: ${DOUBAO_MODEL} // [!code focus]
    volumes:
      - ./ws:/app
    ports:
      - 127.0.0.1:8811:8000
```
- 环境变量也可以直接赋值，比如 `TZ: "Asia/Shanghai"`
- 如果直接赋值了，则不需要进行下面的第2步了


## 2. 编辑 `.env` 文件
如果不存在 `.env` 文件则手动创建，在 `compose.yaml` 同目录下

```bash
DOUBAO_API_KEY="17442e29-xxx-xxxx-xxxx-9911119f76c8"
DOUBAO_MODEL="ep-20240906111111-xxxxx"
```
